Ameba::Rule::Performance::Base - ameba 1.6.4-1-dev

# abstract class Ameba::Rule::Performance::Base

- Ameba::Rule::Performance::Base
- Ameba::Rule::Base
- Reference
- Object

##
Overview

A general base class for performance rules.

##
Included Modules

- YAML::Serializable
- YAML::Serializable::Strict

##
Direct Known Subclasses

- Ameba::Rule::Performance::AnyAfterFilter
- Ameba::Rule::Performance::AnyInsteadOfEmpty
- Ameba::Rule::Performance::ChainedCallWithNoBang
- Ameba::Rule::Performance::CompactAfterMap
- Ameba::Rule::Performance::ExcessiveAllocations
- Ameba::Rule::Performance::FirstLastAfterFilter
- Ameba::Rule::Performance::FlattenAfterMap
- Ameba::Rule::Performance::MapInsteadOfBlock
- Ameba::Rule::Performance::MinMaxAfterMap
- Ameba::Rule::Performance::SizeAfterFilter

##
Defined in:

ameba/rule/performance/base.cr

##
Constructors

- .new(ctx : YAML::ParseContext, node : YAML::Nodes::Node)
- .new(config = nil)

  A general base class for performance rules.

- .new(*, __context_for_yaml_serializable ctx : YAML::ParseContext, __node_for_yaml_serializable node : YAML::Nodes::Node)

##
Class Method Summary

- .parsed_doc : String | Nil

  Returns documentation for this rule, if there is any.

##
Instance Method Summary

- #catch(source : Source)

  A convenient addition to `#test` method that does the same but returns a passed in `source` as an addition.

### Instance methods inherited from class `Ameba::Rule::Base`

==(other) ==, catch(source : Source) catch, excluded?(source) excluded?, group group, hash hash, name name, special? special?, test(source : Source, node : Crystal::ASTNode, *opts)
test(source : Source) test

### Class methods inherited from class `Ameba::Rule::Base`

default_severity : Ameba::Severity default_severity

### Macros inherited from class `Ameba::Rule::Base`

issue_for(*args, **kwargs, &block) issue_for

### Macros inherited from module `Ameba::Config::RuleConfig`

properties(&block) properties

##
Constructor Detail

def self.new(ctx : YAML::ParseContext, node : YAML::Nodes::Node) #
def self.new(config = nil) #

A general base class for performance rules.

def self.new(*, __context_for_yaml_serializable ctx : YAML::ParseContext, __node_for_yaml_serializable node : YAML::Nodes::Node) #

##
Class Method Detail

def self.parsed_doc : String | Nil #

Returns documentation for this rule, if there is any.

    module Ameba
      # This is a test rule.
      # Does nothing.
      class MyRule < Ameba::Rule::Base
        def test(source)
        end
      end
    end

    MyRule.parsed_doc # => "This is a test rule.\nDoes nothing."

##
Instance Method Detail

def catch(source : Source) #
Description copied from class Ameba::Rule::Base

A convenient addition to `#test` method that does the same but returns a passed in `source` as an addition.

    source = MyRule.new.catch(source)
    source.valid?